DECLARE SUB polyfill (x1%, y1%, x2%, y2%, x3%, y3%, C%, texture%)
DECLARE SUB rotateobject (dg%, dg2%, dg3%, from%, too%)
DECLARE SUB CullPolygons ()
DECLARE SUB DrawLine (Xs%, Ys%, Xe%, Ye%, EdgeList() AS ANY)
DECLARE SUB DrawObject ()
DECLARE SUB EdgeFill (EdgeList() AS ANY, YLow%, YHigh%, C%)
DECLARE SUB FindNormals ()

DECLARE SUB RotatePoints ()
DECLARE SUB ShadePolygons ()
CONST pi = 3.141593

'TYPE EdgeType              'for fast polygon rasterization
'    Low         AS INTEGER
'    High        AS INTEGER
'END TYPE
TYPE PointType
    xobject     AS INTEGER 'original coordinate
    yobject     AS INTEGER
    zobject     AS INTEGER 'rotated coordinate
    xworld      AS INTEGER
    yworld      AS INTEGER
    zworld      AS INTEGER
    xview       AS INTEGER 'rotated & translated coordinate
    yview       AS INTEGER
    viewed      AS INTEGER
    texture     AS INTEGER
END TYPE
TYPE PolyType
    p1          AS INTEGER '3 points which make up the polygon (points
    p2          AS INTEGER 'to the point list array)
    p3          AS INTEGER
    Culled      AS INTEGER 'True if plane not visible
    ZCenter     AS INTEGER 'Z center of polygon
    ZOrder      AS INTEGER 'Used in the shell sort of the ZCenters
 '   Intensity   AS INTEGER 'Intensity of polygon
    WorldXN     AS INTEGER 'Contains the coordinates of the point
    WorldYN     AS INTEGER ' which is both perpendicular and a constant
    WorldZN     AS INTEGER ' distance from the polygon
    NormalX     AS INTEGER 'Normal of polygon -128 to 128
    NormalY     AS INTEGER ' (used for fast Lambert shading)
    NormalZ     AS INTEGER
    text AS INTEGER
END TYPE
'TYPE LineType
'    p1          AS INTEGER 'Used for shadow projection
'    p2          AS INTEGER
'END TYPE
'DIM SHARED handle%(32 * 32 + 100)
'$INCLUDE: 'DIRECTQB.BI'
CLS
SCREEN 0, 0, 0, 0
LOCATE 1, 1: PRINT "init library......"
		   COLOR 15, 9: LOCATE 23, 1: PRINT STRING$(77, " ")
		   COLOR 15, 9: LOCATE 23: PRINT "checking system"
		   COLOR 7, 0

IF DQBinit(2, 0, 0) THEN DQBclose: PRINT DQBerror$: END


LOCATE 1, 30: PRINT "Ok"

LOCATE 2, 1: PRINT "free memory..."

'DIM SHARED EdgeList(199) AS EdgeType
DIM SHARED SINetable(359 + 90) AS INTEGER 'cos(X)=sin(X+90)
DIM SHARED r1, R2, r3, ox, oy, oz
DIM SHARED maxpoints, maxpolys, poly%
DIM SHARED polys(1000) AS PolyType
DIM SHARED points(1000) AS PointType
DIM SHARED texture1(4200) AS INTEGER, texture2(4200) AS INTEGER, texture3(4200) AS INTEGER
DIM SHARED texture4(4200) AS INTEGER, texture5(4200) AS INTEGER
DIM SHARED texture6(4200) AS INTEGER, texture7(4200) AS INTEGER, texture8(4200) AS INTEGER
DIM SHARED texture9(4200) AS INTEGER, texture10(4200) AS INTEGER
DIM SHARED pal AS STRING * 768
DIM SHARED S, XLow(1), XHigh(1), YLow(1), YHigh(1)
'DIM SHARED ShadowXLow(1), ShadowXHigh(1), ShadowYLow(1), ShadowYHigh(1)
'DIM SHARED Lx, Ly, Lz
LOCATE 2, 30: PRINT "Ok"
   'resetscreen
LOCATE 3, 1: PRINT "Loading map..."
'      'FOR i% = 0 TO 3
	       OPEN "..\3deditor\obc.3dt" FOR INPUT AS #1
		      INPUT #1, inline$
		      oldpnt = maxpoints + 1
		      maxpoints = VAL(inline$) + maxpoints + 1
		      'IF maxpoints >= 1000 THEN maxpoints = 1000
		      COLOR 15, 9: LOCATE 23, 1: PRINT STRING$(77, " ")
		      FOR ln% = oldpnt TO maxpoints
			INPUT #1, inline$
			points(ln%).xobject = VAL(inline$)  '- 1000
		       INPUT #1, inline$
			points(ln%).yobject = VAL(inline$) '+ 250
			INPUT #1, inline$
			points(ln%).zobject = VAL(inline$)  '+ 120
			'WAIT &H3DA, 8
			COLOR 15, 9: LOCATE 23: PRINT "points :" + STR$(INT(ln% / maxpoints * 100)) + "% "
			LOCATE 23, 55: PRINT STRING$(INT(ln% / maxpoints * 20), "")
		     
		      NEXT
		      INPUT #1, inline$
		      oldp = maxpolys + 1
		     maxpolys = VAL(inline$) + maxpolys + 1
		      COLOR 15, 9: LOCATE 23, 1: PRINT STRING$(77, " ")
		      FOR ln% = oldp TO maxpolys
		       INPUT #1, inline$
			polys(ln%).p1 = VAL(inline$) + oldpnt
			INPUT #1, inline$
			polys(ln%).p2 = VAL(inline$) + oldpnt
			INPUT #1, inline$
			polys(ln%).p3 = VAL(inline$) + oldpnt
'                        INPUT #1, inline$
			polys(ln%).text = 1'VAL(inline$)
		     
		       'WAIT &H3DA, 8
			COLOR 15, 9: LOCATE 23: PRINT "polys :" + STR$(INT(ln% / maxpolys * 100)) + "% "
			LOCATE 23, 55: PRINT STRING$(INT(ln% / (maxpolys) * 20), "")
		     
		      NEXT
		      COLOR 7, 0
		CLOSE #1
	 '       NEXT
LOCATE 3, 30: PRINT "Ok"
LOCATE 4, 1: PRINT "loading objects..."
'               OPEN "car001.3dt" FOR INPUT AS #1
'                      INPUT #1, inline$
		      'PRINT inline$
		      oldpnt = maxpoints + 1
		      
	 '             maxpoints = VAL(inline$) + maxpoints + 1
	  '            pnts% = maxpoints - oldpnt
	   '           'PRINT maxpoints
	    '          COLOR 15, 9: LOCATE 23, 1: PRINT STRING$(77, " ")
	     '         FOR ln% = oldpnt TO maxpoints
	     '           INPUT #1, inline$
	     '           points(ln%).xobject = VAL(inline$) / 3
	     '           INPUT #1, inline$
	     '           points(ln%).yobject = VAL(inline$) / 3 - 25
	     '           INPUT #1, inline$
	     '           points(ln%).zobject = VAL(inline$) / 3
	     '
	     '          ' WAIT &H3DA, 8
	     '           COLOR 15, 9: LOCATE 23: PRINT "points :" + STR$(INT((ln% - oldpnt + 1) / (maxpoints - oldpnt) * 100)) + "% "
	     '           LOCATE 23, 55: PRINT STRING$(INT((ln% - oldpnt + 1) / (maxpoints - oldpnt) * 20), "")
	     '           NEXT
	     '           COLOR 7, 0
	     '         INPUT #1, inline$
		      oldp = maxpolys + 1
	     '         maxpolys = VAL(inline$) + maxpolys + 1
	     '         COLOR 15, 9: LOCATE 23, 1: PRINT STRING$(77, " ")
	     '         FOR ln% = oldp TO maxpolys
	     '          INPUT #1, inline$
	     '           polys(ln%).p1 = VAL(inline$) + oldpnt
	     '           INPUT #1, inline$
	     '           polys(ln%).p2 = VAL(inline$) + oldpnt
	     '           INPUT #1, inline$
	     '           polys(ln%).p3 = VAL(inline$) + oldpnt
	     '           INPUT #1, inline$
	     '           polys(ln%).text = 3
	     '           'WAIT &H3DA, 8
	     '           COLOR 15, 9: LOCATE 23: PRINT "polys :" + STR$(INT((ln% - oldp + 1) / (maxpolys - oldp) * 100)) + "% "
	     '           LOCATE 23, 55: PRINT STRING$(INT((ln% - oldp) / (maxpolys - oldp) * 20), "")
	     '         NEXT
	     '         COLOR 7, 0
	     '   CLOSE #1
	     '       rotateobject 88, 0, 0, oldpnt, maxpoints
LOCATE 4, 30: PRINT "Ok"
LOCATE 5, 1: PRINT "Loading textures..."
		   'WAIT &H3DA, 8
		   dir$ = " d:\qb3d\"
		   filename$ = dir$ + "pal200.bmp"
		   COLOR 15, 9: LOCATE 23, 1: PRINT STRING$(77, " ")
		   COLOR 15, 9: LOCATE 23: PRINT "texture: " + dir$ + filename$
		   COLOR 7, 0
		   IF DQBloadImage(2, 0, 0, "pal200.bmp", pal, a, a) THEN PRINT "Error loading ECLOGO.PCX, program aborted": DQBclose: END
		   DQBget 2, 0, 0, 63, 63, VARSEG(texture1(0)), VARPTR(texture1(0))
		   filename$ = dir$ + "tex002.bmp"
		   COLOR 15, 9: LOCATE 23, 1: PRINT STRING$(77, " ")
		   COLOR 15, 9: LOCATE 23: PRINT "texture: " + dir$ + filename$
		   COLOR 7, 0
		   IF DQBloadImage(2, 0, 0, "tex002.bmp", pal, a, a) THEN PRINT "Error loading ECLOGO.PCX, program aborted": DQBclose: END
		   DQBget 2, 0, 0, 63, 63, VARSEG(texture2(0)), VARPTR(texture2(0))
		   filename$ = dir$ + "tex003.bmp"
		   COLOR 15, 9: LOCATE 23, 1: PRINT STRING$(77, " ")
		   COLOR 15, 9: LOCATE 23: PRINT "texture: " + dir$ + filename$
		   COLOR 7, 0
		   IF DQBloadImage(2, 0, 0, "tex003.bmp", pal, a, a) THEN PRINT "Error loading ECLOGO.PCX, program aborted": DQBclose: END
		   DQBget 2, 0, 0, 63, 63, VARSEG(texture3(0)), VARPTR(texture3(0))
		   filename$ = dir$ + "tex004.bmp"
		   COLOR 15, 9: LOCATE 23, 1: PRINT STRING$(77, " ")
		   COLOR 15, 9: LOCATE 23: PRINT "texture: " + dir$ + filename$
		   COLOR 7, 0
		   IF DQBloadImage(2, 0, 0, "tex004.bmp", pal, a, a) THEN PRINT "Error loading ECLOGO.PCX, program aborted": DQBclose: END
		   DQBget 2, 0, 0, 63, 63, VARSEG(texture4(0)), VARPTR(texture4(0))
		   filename$ = dir$ + "tex005.bmp"
		   COLOR 15, 9: LOCATE 23, 1: PRINT STRING$(77, " ")
		   COLOR 15, 9: LOCATE 23: PRINT "texture: " + dir$ + filename$
		   COLOR 7, 0
		   IF DQBloadImage(2, 0, 0, "tex005.bmp", pal, a, a) THEN PRINT "Error loading ECLOGO.PCX, program aborted": DQBclose: END
		   DQBget 2, 0, 0, 63, 63, VARSEG(texture5(0)), VARPTR(texture5(0))
		  
		   filename$ = dir$ + "tex101.bmp"
		   COLOR 15, 9: LOCATE 23, 1: PRINT STRING$(77, " ")
		   COLOR 15, 9: LOCATE 23: PRINT "texture: " + dir$ + filename$
		   COLOR 7, 0
		   IF DQBloadImage(2, 0, 0, "tex201.bmp", pal, a, a) THEN PRINT "Error loading ECLOGO.PCX, program aborted": DQBclose: END
		   DQBget 2, 0, 0, 63, 63, VARSEG(texture6(0)), VARPTR(texture6(0))
		   filename$ = dir$ + "tex102.bmp"
		   COLOR 15, 9: LOCATE 23, 1: PRINT STRING$(77, " ")
		   COLOR 15, 9: LOCATE 23: PRINT "texture: " + dir$ + filename$
		   COLOR 7, 0
		   IF DQBloadImage(2, 0, 0, "tex202.bmp", pal, a, a) THEN PRINT "Error loading ECLOGO.PCX, program aborted": DQBclose: END
		   DQBget 2, 0, 0, 63, 63, VARSEG(texture7(0)), VARPTR(texture7(0))
		   filename$ = dir$ + "tex103.bmp"
		   COLOR 15, 9: LOCATE 23, 1: PRINT STRING$(77, " ")
		   COLOR 15, 9: LOCATE 23: PRINT "texture: " + dir$ + filename$
		   COLOR 7, 0
		   IF DQBloadImage(2, 0, 0, "tex203.bmp", pal, a, a) THEN PRINT "Error loading ECLOGO.PCX, program aborted": DQBclose: END
		   DQBget 2, 0, 0, 63, 63, VARSEG(texture8(0)), VARPTR(texture8(0))
		   filename$ = dir$ + "tex104.bmp"
		   COLOR 15, 9: LOCATE 23, 1: PRINT STRING$(77, " ")
		   COLOR 15, 9: LOCATE 23: PRINT "texture: " + dir$ + filename$
		   COLOR 7, 0
		   IF DQBloadImage(2, 0, 0, "tex204.bmp", pal, a, a) THEN PRINT "Error loading ECLOGO.PCX, program aborted": DQBclose: END
		   DQBget 2, 0, 0, 63, 63, VARSEG(texture9(0)), VARPTR(texture9(0))
		   filename$ = dir$ + "tex105.bmp"
		   COLOR 15, 9: LOCATE 23, 1: PRINT STRING$(77, " ")
		   COLOR 15, 9: LOCATE 23: PRINT "texture: " + dir$ + filename$
		   COLOR 7, 0
		   IF DQBloadImage(2, 0, 0, "pal200.bmp", pal, a, a) THEN PRINT "Error loading ECLOGO.PCX, program aborted": DQBclose: END
		   DQBget 2, 0, 0, 63, 63, VARSEG(texture2(0)), VARPTR(texture2(0))



LOCATE 5, 30: PRINT "Ok"


LOCATE 6, 1: PRINT "Setting up enginge..."
'Center the object
x = x \ (maxpoints + 1): y = y \ (maxpoints + 1): z = z \ (maxpoints + 1)
''FOR a = 0 TO maxpoints
'    points(a).xobject = points(a).xobject - X
'    points(a).yobject = points(a).yobject - Y
'    points(a).zobject = points(a).zobject - Z
'NEXT
'FOR a = 0 TO maxpolys
'    READ polys(a).p1, polys(a).p2, polys(a).p3
'NEXT
'FOR a = 0 TO MaxLines
'    READ lines(a).p1, lines(a).p2
'NEXT

'Precalculate the normal point of each polygon for fast Lambert shading

'FindNormals

'Precalculate the sine table
a = 0

FOR a! = 0 TO (359 + 90) / 57.29 STEP 1 / 57.29
    SINetable(a) = SIN(a!) * 1024: a = a + 1
NEXT

'Some light source configurations won't work that great!
l1 = 70: l2 = 40           'light source's spherical coordinates
a1! = l1 / 57.29: a2! = l2 / 57.29

s1! = SIN(a1!): c1! = COS(a1!)
s2! = SIN(a2!): c2! = COS(a2!)
Lx = 128 * s1! * c2!        'convert spherical coordinates to a vector
Ly = 128 * s1! * s2!        'scale up by 128 for integer math
Lz = 128 * c1!

'FOR a = -128 TO 128         'precalculate the three light source tables
'    Lx(a + 128) = Lx * a    'for fast Lambert shading
'    Ly(a + 128) = Ly * a
'    Lz(a + 128) = Lz * a
'NEXT

r1 = 0: R2 = 0: r3 = 0      'three angles of rotation
ox = 0: oy = -50: oz = 1100 'object's origin (this program cannot
			    'currently handle the object when it goes
		    'behind the viewer!)
S = 1: T = 0

DIM SHARED viewx%, viewy%
'set320x200 8
viewx% = 320
viewy% = 200


YHigh(0) = -32768: ShadowYHigh(0) = -32768
YHigh(1) = -32768: ShadowYHigh(1) = -32768

Startime! = TIMER
YHigh(0) = -32768
ShadowYHigh(0) = -32768
YHigh(1) = -32768
ShadowYHigh(1) = -32768
Startime! = TIMER
LOCATE 6, 30: PRINT "Ok"
LOCATE 7, 1: PRINT "Creating bmap."
LOCATE 7, 30: PRINT "Ok"
LOCATE 9, 1: PRINT "Left = a, right = d, faster = left MouseButton and for = right one"
LOCATE 10, 1: PRINT "Switching to vga mode..."
LOCATE 11, 1: PRINT "Press a key"
SLEEP

DQBinitVGA
		   DQBsetPal pal
		  
IF DQBloadImage(2, 0, 0, "tex205.bmp", pal, a, a) THEN PRINT "Error loading ECLOGO.PCX, program aborted": DQBclose: END
DQBget 2, 0, 0, 63, 63, VARSEG(texture10(0)), VARPTR(texture10(0))

'ok& = SETMEM(-257)
'ok = DQBcreateBMap(0, 60, 60)


     '   FOR i = 0 TO 255
     '   DQBgetCol i, r, g, b
     '   hue = (r + g + b) / 2.5
     '   col = DQBfindCol(hue, hue, 0)
     '   DQBsetBMap 0, 60, i, col
     '   NEXT


r3 = 0
'OPEN "movie.3dm" FOR OUTPUT AS #1
DO 'WHILE NOT EOF(1)
 'Flip Active And Work Pages So User Doesn't See Our Messy Drawing
 dqbclearlayer 1
 FPS% = FPS% + 1

 
 Newtime! = TIMER
  dqbboxf 1, 0, 0, 319, 199, 255 - 48
 IF Newtime! - Startime! >= 1 THEN Startime! = TIMER: Showfps$ = STR$(FPS%): FPS% = 0
 'Wait For Vertical Retrace To Reduce Flicker
 'WAIT &H3DA, 8
 'Erase The Old Image From The Screen

 RotatePoints
 CullPolygons
 
 'XLow(S) = 32767
 'XHigh(S) = -32768
 'YLow(S) = 32767
 'YHigh(S) = -32768
 'DrawShadows
 DrawObject
 DQBPRINT 1, Showfps$, 0, 0, 15
    r1 = (r1 + d1) MOD 360: IF r1 < 0 THEN r1 = r1 + 360
    R2 = (R2 + D2) MOD 360: IF R2 < 0 THEN R2 = R2 + 360
    r3 = (r3 + D3) MOD 360: IF r3 < 0 THEN r3 = r3 + 360
	oz = oz + dz: ox = ox + dx
 IF oz < 90 THEN
	oz = 90
  dz = 0
 ELSEIF oz > 8000 THEN
	oz = 8000
  dz = 0
 END IF


 IF ox < -4000 THEN
	ox = -4000
  dx = 0
 ELSEIF ox > 4000 THEN
	ox = 4000
  dx = 0
 END IF

 a$ = INKEY$
'
 SELECT CASE a$
    CASE "4"
	d1 = d1 - 2
    CASE "6"
	d1 = d1 + 2
    CASE "8"
	D2 = D2 - 2
    CASE "2"
	D2 = D2 + 2
    CASE "5"
	d1 = 0: D2 = 0: D3 = 0
    CASE "0"
	r1 = 0: R2 = 0: r3 = 0
	d1 = 0: D2 = 0: D3 = 0
    CASE "+"
	D3 = D3 + 2
    CASE "-"
	D3 = D3 - 2
    CASE CHR$(0) + CHR$(72)
	dz = dz - 20
    CASE CHR$(0) + CHR$(80)
	dz = dz + 20
    CASE CHR$(0) + CHR$(77)
	dx = dx - 20
    CASE CHR$(0) + CHR$(75)
	dx = dx + 20

 CASE CHR$(27)
	END
END SELECT
    lastdr = 0
    IF DQBmouseX > conx% THEN rotateobject 2, 0, 0, 0, oldpnt - 1: lastdr = 2
    IF DQBmouseX < conx% THEN rotateobject -2, 0, 0, 0, oldpnt - 1: lastdr = -2
   ' PRINT #1, STR$(lastdr)
    'INPUT #1, inline$
    'rotateobject VAL(inline$), 0, 0, 0, oldpnt - 1: lastdr = VAL(inline$)
    IF DQBmouseRB% AND sp% < 40 THEN sp% = sp% + 1
    'INPUT #1, inline$
    'sp% = VAL(inline$)
 '   PRINT #1, STR$(sp%)
  '  PRINT #1, STR$(DQBmouseLB%)
    IF DQBmouseLB% THEN
    'sp% = sp% + 40
    'GOSUB checkpoly
    'sp% = sp% - 40
    IF polys(poly%).text < 2 THEN
    FOR i% = 0 TO maxpoints - (maxpoints - oldpnt) - 1
      points(i%).zobject = points(i%).zobject - sp%
    NEXT
    END IF
     sp% = sp% * 2
     'GOSUB checkpoly
     sp% = sp% / 2
    IF polys(checkforpoly).text = 2 THEN
    
    FOR i% = 0 TO maxpoints - (maxpoints - oldpnt) - 1
      points(i%).zobject = points(i%).zobject + sp%
    NEXT
    END IF
    
	  oldcurpol = curpol
    END IF
   IF DQBmouseX >= 318 THEN dqbsetmousepos 1, DQBmouseY
   IF DQBmouseX <= 0 THEN dqbsetmousepos 319, DQBmouseY


  conx% = DQBmouseX
  'cony% = DQBmouseY
 
   ' GOSUB checkpoly
 
  'IF DQBmouseY <= 100 THEN r3 = 258 + (199 - DQBmouseY)
  'IF DQBmouseY > 100 THEN r3 = (199 - DQBmouseY) - 100
   msx% = 200 - DQBmouseY
   r3 = msx% + 260
   IF r3 >= 359 THEN r3 = r3 - 359
  dqbcopylayer 1, VIDEO
 'END IF

LOOP
END




checkpoly:
       px = 0
      FOR aj% = 0 TO oldp - 1
	 checkforpoly = aj%
	 p1x = points(polys(aj%).p1).xobject
	 p2x = points(polys(aj%).p2).xobject
	 p3x = points(polys(aj%).p3).xobject
	 p1z = points(polys(aj%).p1).zobject
	 p2z = points(polys(aj%).p2).zobject
	 p3z = points(polys(aj%).p3).zobject
	 
	IF p1x >= 0 AND p2x <= -0 AND p3x <= -0 THEN
	     px = 1: GOSUB checkz:
		IF px = 2 THEN
		checkforpoly = aj%
		EXIT FOR
		END IF
	 END IF
	IF p1x >= 0 AND p2x >= 0 AND p3x <= -0 THEN
	     px = 1: GOSUB checkz:
		IF px = 2 THEN
		checkforpoly = aj%
		EXIT FOR
		END IF
	 END IF
	IF p1x >= 0 AND p2x <= -0 AND p3x >= 0 THEN
	     px = 1: GOSUB checkz:
		IF px = 2 THEN
		checkforpoly = aj%
		EXIT FOR
		END IF
	 END IF
	IF p1x <= -0 AND p2x >= 0 AND p3x >= 0 THEN
	     px = 1: GOSUB checkz:
		IF px = 2 THEN
		checkforpoly = aj%
		EXIT FOR
		END IF
	 END IF
	IF p1x <= -0 AND p2x >= 0 AND p3x <= -0 THEN
	     px = 1: GOSUB checkz:
		IF px = 2 THEN
		checkforpoly = aj%
		EXIT FOR
		END IF
	 END IF
	IF p1x <= -0 AND p2x <= -0 AND p3x >= 0 THEN
	     px = 1: GOSUB checkz:
		IF px = 2 THEN
		checkforpoly = aj%
		EXIT FOR
		END IF
	 END IF
     
						  
    
      NEXT
   RETURN
checkz:
	IF p1z >= sp% AND p2z <= sp% AND p3z <= sp% THEN px = px + 1: RETURN
	IF p1z >= sp% AND p2z >= sp% AND p3z <= sp% THEN px = px + 1: RETURN
	IF p1z >= sp% AND p2z <= sp% AND p3z >= sp% THEN px = px + 1: RETURN
	IF p1z <= sp% AND p2z >= sp% AND p3z >= sp% THEN px = px + 1: RETURN
	IF p1z <= sp% AND p2z >= sp% AND p3z <= sp% THEN px = px + 1: RETURN
	IF p1z <= sp% AND p2z <= sp% AND p3z >= sp% THEN px = px + 1: RETURN
RETURN

REM $DYNAMIC
'Shades The Polygons Using Lambert Shading. Notice The Total Lack Of
'floating Point Math- Only 1 Divide Is Required For Each Polygon Shaded.
'(This Divide Can Be Eliminated, But The Shading Won't Be As Accurate.)
'"Culls" The Polygons Which Aren't Visible To The Viewer. Also Shades
'each Polygon Using Lambert's Law.
SUB CullPolygons
'This Algorithm For Removing Hidden Faces Was Developed By Dave
'Cooper.
'There Is Another Method, By Finding The Dot Product Of The
'plane's Normal And The Viewing Vector, But This Algorithm Is
'much Faster Because Of Its Simplicity(And Lack Of Floating Point
'calculations).

FOR a = 0 TO maxpolys - 1
	IF points(polys(a).p1).xobject >= -1400 AND points(polys(a).p1).zobject >= -800 AND points(polys(a).p1).xobject <= 1400 AND points(polys(a).p1).zobject <= 2400 THEN
	p1 = polys(a).p1: p2 = polys(a).p2: p3 = polys(a).p3

	IF points(p1).yview <= points(p2).yview THEN
	    IF points(p3).yview < points(p1).yview THEN
		PTop = p3: PNext = p1: PLast = p2
	    ELSE
		PTop = p1: PNext = p2: PLast = p3
	    END IF
	ELSE
	    IF points(p3).yview < points(p2).yview THEN
		PTop = p3: PNext = p1: PLast = p2
	    ELSE
		PTop = p2: PNext = p3: PLast = p1
	    END IF
	END IF
	XLow = points(PTop).xview
	YLow = points(PTop).yview
	XNext = points(PNext).xview
	XLast = points(PLast).xview
	IF XNext <= XLow AND XLast >= XLow THEN
	    polys(a).Culled = TRUE
	ELSEIF XNext >= XLow AND XLast <= XLow THEN
	    polys(a).Culled = False
	ELSE
	    YNext = points(PNext).yview: YLast = points(PLast).yview

 IF ((YNext - YLow) * 256&) \ (XNext - XLow) < ((YLast - YLow) * 256&) \ (XLast - XLow) THEN
		polys(a).Culled = False
	    ELSE
		polys(a).Culled = TRUE
	    END IF
	END IF
 END IF
 NEXT

 END SUB

SUB DrawObject
    'Find the center of each visible polygon, and prepare the orderlist.
    NumPolys = 0
    FOR a = 0 TO maxpolys - 1
	IF polys(a).Culled = False THEN 'is this polygon visible?
	    polys(NumPolys).ZOrder = a
	    NumPolys = NumPolys + 1
	    polys(a).ZCenter = points(polys(a).p1).zworld + points(polys(a).p2).zworld + points(polys(a).p3).zworld
	    polys(a).ZCenter = polys(a).ZCenter + points(polys(a).p1).yworld + points(polys(a).p2).yworld + points(polys(a).p3).yworld
	END IF
    NEXT
    'Sort the visible polygons by their Z center using a shell sort.
    NumPolys = NumPolys - 1
    Mid = (NumPolys + 1) \ 2
    DO
	FOR a = 0 TO NumPolys - Mid
	    CompareLow = a
	    CompareHigh = a + Mid
		DO WHILE polys(polys(CompareLow).ZOrder).ZCenter < polys(polys(CompareHigh).ZOrder).ZCenter
		SWAP polys(CompareLow).ZOrder, polys(CompareHigh).ZOrder
		CompareHigh = CompareLow
		CompareLow = CompareLow - Mid
		IF CompareLow < 0 THEN EXIT DO
	    LOOP
	NEXT
	Mid = Mid \ 2
    LOOP WHILE Mid > 0
    'Plot the visible polygons.
   
    'Setpage 1
    'WAIT &H3DA, 8
    
    FOR z = 0 TO NumPolys
	a = polys(z).ZOrder 'which polygon do we plot?
	p1 = polys(a).p1: p2 = polys(a).p2: p3 = polys(a).p3
       
	IF points(p1).viewed AND points(p2).viewed AND points(p3).viewed THEN
	 IF points(p1).zobject <= 400 THEN polyfill (points(p1).xview), (points(p1).yview), (points(p2).xview), (points(p2).yview), (points(p3).xview), (points(p3).yview), 1, polys(a).text
	 IF points(p1).zobject > 400 AND points(p1).zobject <= 800 THEN polyfill (points(p1).xview), (points(p1).yview), (points(p2).xview), (points(p2).yview), (points(p3).xview), (points(p3).yview), 2, polys(a).text
	 IF points(p1).zobject > 800 AND points(p1).zobject <= 1800 THEN polyfill (points(p1).xview), (points(p1).yview), (points(p2).xview), (points(p2).yview), (points(p3).xview), (points(p3).yview), 3, polys(a).text
	 IF points(p1).zobject > 1800 AND points(p1).zobject <= 2400 THEN polyfill (points(p1).xview), (points(p1).yview), (points(p2).xview), (points(p2).yview), (points(p3).xview), (points(p3).yview), 4, polys(a).text
	 IF points(p1).zobject > 2400 THEN polyfill (points(p1).xview), (points(p1).yview), (points(p2).xview), (points(p2).yview), (points(p3).xview), (points(p3).yview), 5, polys(a).text

       END IF
    NEXT
    
END SUB

'Draws A Polygon To The Screen. Simply Finds The Start And Stop X
'coordinates For Each Scan Line Within The Polygon And Uses The
'LINE Command For Filling.
SUB polyfill (x1, y1, x2, y2, x3, y3, C, texture) 'for QB 4.5 Guys
'find Lowest And High X & Y Coordinates
IF y1 < y2 THEN YLow = y1 ELSE YLow = y2
IF y3 < YLow THEN YLow = y3
IF y1 > y2 THEN YHigh = y1 ELSE YHigh = y2
IF y3 > YHigh THEN YHigh = y3
IF x1 < x2 THEN XLow = x1 ELSE XLow = x2
IF x3 < XLow THEN XLow = x3
IF x1 > x2 THEN XHigh = x1 ELSE XHigh = x2
IF x3 > XHigh THEN XHigh = x3
IF YLow < 0 THEN YLow = 0
IF YHigh > 199 THEN YHigh = 199
IF XLow < XLow(S) THEN XLow(S) = XLow
IF XHigh > XHigh(S) THEN XHigh(S) = XHigh
IF YLow < YLow(S) THEN YLow(S) = YLow
IF YHigh > YHigh(S) THEN YHigh(S) = YHigh
'check For Polygons Which Cannot Be Visible
IF YHigh < 0 OR YLow > 199 OR XLow > 319 OR XHigh < 0 THEN EXIT SUB
'initialize The Edge List

'FOR a = YLow TO YHigh
'        EdgeList(a).Low = 32767
'        EdgeList(a).High = -32768
'NEXT

'Remember The Lowest & Highest X And Y Coordinates Drawn To The
'screen For Later Erasing
'Find The Start And Stop X Coordinates For Each Scan Line
'IF points(a).viewed = 1 THEN
'IF (x1 <= 0 OR x1 >= 320) AND (y1 <= 0 OR y1 >= 320) THEN
SELECT CASE texture
CASE 1
SELECT CASE C
CASE 1
dqbttri 1, x1, y1, x2, y2, x3, y3, 0, 0, 63, 0, 0, 63, VARSEG(texture1(0)), VARPTR(texture1(0))
CASE 2
dqbttri 1, x1, y1, x2, y2, x3, y3, 0, 0, 63, 0, 0, 63, VARSEG(texture2(0)), VARPTR(texture2(0))
CASE 3
dqbttri 1, x1, y1, x2, y2, x3, y3, 0, 0, 63, 0, 0, 63, VARSEG(texture3(0)), VARPTR(texture3(0))
CASE 4
dqbttri 1, x1, y1, x2, y2, x3, y3, 0, 0, 63, 0, 0, 63, VARSEG(texture4(0)), VARPTR(texture4(0))
CASE ELSE
dqbttri 1, x1, y1, x2, y2, x3, y3, 0, 0, 63, 0, 0, 63, VARSEG(texture5(0)), VARPTR(texture5(0))
END SELECT
CASE 2
SELECT CASE C
CASE 1
dqbttri 1, x1, y1, x2, y2, x3, y3, 0, 0, 63, 0, 0, 63, VARSEG(texture6(0)), VARPTR(texture6(0))
CASE 2
dqbttri 1, x1, y1, x2, y2, x3, y3, 0, 0, 63, 0, 0, 63, VARSEG(texture7(0)), VARPTR(texture7(0))
CASE 3
dqbttri 1, x1, y1, x2, y2, x3, y3, 0, 0, 63, 0, 0, 63, VARSEG(texture8(0)), VARPTR(texture8(0))
CASE 4
dqbttri 1, x1, y1, x2, y2, x3, y3, 0, 0, 63, 0, 0, 63, VARSEG(texture9(0)), VARPTR(texture9(0))
CASE ELSE
dqbttri 1, x1, y1, x2, y2, x3, y3, 0, 0, 63, 0, 0, 63, VARSEG(texture10(0)), VARPTR(texture10(0))
END SELECT
CASE 3
dqbtri 1, x1, y1, x2, y2, x3, y3, texture
END SELECT
'END IF
'END IF
'DrawLine (x1), (y1), (x2), (y2), EdgeList()
'DrawLine (x2), (y2), (x3), (y3), EdgeList()
'DrawLine (x3), (y3), (x1), (y1), EdgeList()
'EdgeFill EdgeList(), YLow, YHigh, C
END SUB

REM $STATIC
SUB rotateobject (dg%, dg2%, dg3%, from%, too%)
  
    'lookup the sine and cosine of each angle...
'    s1& = SINetable(dg%): c1& = SINetable(dg% + 90)
'    s2& = SINetable(10): c2& = SINetable(90)
'    s3& = SINetable(10): c3& = SINetable(90)

    'rotate the points of the object
    FOR a = from% TO too%

	xo = points(a).xobject
	yo = points(a).yobject
	zo = points(a).zobject
	GOSUB Rotate3D2
	points(a).xobject = x1
	points(a).yobject = points(a).yobject
	points(a).zobject = z1
      
    NEXT
    EXIT SUB
 
Rotate3D2:
    x1 = (xo * COS(dg% * pi / 180) - zo * SIN(dg% * pi / 180))
    z1 = (xo * SIN(dg% * pi / 180) + zo * COS(dg% * pi / 180))
  
							 '57.29

    'x1 = (xo * c1& - zo * s1&) \ 1024 '+ xo
    'z1 = (xo * s1& + zo * c1&) \ 1024 '+ zo

    'z3 = (z1 * c3& - yo * s3&) \ 1024 * zo' zo 'pitch
    'y2 = (z1 * s3& + yo * c3&) \ 1024

    'x2 = (x1 * c2& + y2 * s2&) \ 1024 \ xo'xo 'roll
    'y3 = (y2 * c2& - x1 * s2&) \ 1024 \ yo' yo

RETURN

END SUB

REM $DYNAMIC
'Rotates The Points Of The Object And The Object's Normals.
'Avoids Floating Point Math For Speed.
SUB RotatePoints

    'lookup the sine and cosine of each angle...
    s1& = SINetable(r1): c1& = SINetable(r1 + 90)
    s2& = SINetable(R2): c2& = SINetable(R2 + 90)
    s3& = SINetable(r3): c3& = SINetable(r3 + 90)

    'rotate the points of the object
    FOR a = 0 TO maxpoints
       IF points(a).xobject >= -2800 AND points(a).zobject >= -1200 AND points(a).xobject <= 2800 AND points(a).zobject <= 4800 THEN
	xo = points(a).xobject
	yo = points(a).yobject
	zo = points(a).zobject
	GOSUB Rotate3D
	IF z3 < 40 THEN
	points(a).viewed = 0
	ELSE
	points(a).viewed = 1
	points(a).xview = 160 + (x2 * 400&) \ z3
	points(a).yview = 100 + (y3 * 300&) \ z3
	END IF
	points(a).xworld = x2
	points(a).yworld = y3
	points(a).zworld = z3
	ELSE
	points(a).viewed = 0
	END IF
       
    NEXT
    'rotate the normals of each polygon...
    'FOR a = 0 TO maxpolys
    '    xo = polys(a).WorldXN
    '    yo = polys(a).WorldYN
    '    zo = polys(a).WorldZN
    '    GOSUB Rotate3D
    '    p1 = polys(a).p1
    '    'unorigin the point
    '    x2 = x2 - points(p1).xworld
    '    y3 = y3 - points(p1).YWorld
    '    z3 = z3 - points(p1).zworld
    '    'check the bounds just in case of a round off error
    '    IF x2 < -128 THEN x2 = -128 ELSE IF x2 > 128 THEN x2 = 128
    '    IF y3 < -128 THEN y3 = -128 ELSE IF y3 > 128 THEN y3 = 128
    '    IF z3 < -128 THEN z3 = -128 ELSE IF z3 > 128 THEN z3 = 128
    '    'store the normal back; it's now ready for the shading
    '    'calculations (which are simplistic now)
    '    polys(a).NormalX = x2 + 128
    '    polys(a).NormalY = y3 + 128
    '    polys(a).NormalZ = z3 + 128
    'NEXT
    EXIT SUB

Rotate3D:
    x1 = (xo * c1& - zo * s1&) \ 1024 'yaw
    z1 = (xo * s1& + zo * c1&) \ 1024

    z3 = (z1 * c3& - yo * s3&) \ 1024 + oz 'pitch
    y2 = (z1 * s3& + yo * c3&) \ 1024

    x2 = (x1 * c2& + y2 * s2&) \ 1024 + ox 'roll
    y3 = (y2 * c2& - x1 * s2&) \ 1024 + oy

RETURN
END SUB

