DECLARE SUB polyfill (x1%, y1%, x2%, y2%, x3%, y3%, C%, texture%)
DECLARE SUB Cullpolygons ()
DECLARE SUB DrawObject ()
DECLARE SUB install ()
DECLARE SUB Loadfile (file$)
DECLARE SUB rotatepoints ()
DECLARE SUB ShadePolygons ()
DECLARE FUNCTION getems% (var%, address%)

DECLARE SUB Findnormals ()
DECLARE SUB putems (var%, address%, vardata%)

DEFINT A-Z

'$INCLUDE: 'directqb.bi'
'$INCLUDE: '3dloc.bi'

DIM SHARED SineTable(359 + 90) AS LONG 'cos(x)=sin(x+90)
DIM SHARED r1, R2, r3, ox, oy, oz
DIM SHARED maxpoints, maxpolys, MaxLines

DIM SHARED lx(256), ly(256), lz(256)  'lookup tables for Lambert shading

DIM SHARED S, XLow(1), XHigh(1), YLow(1), YHigh(1)
DIM SHARED ShadowXLow(1), ShadowXHigh(1), ShadowYLow(1), ShadowYHigh(1)
DIM SHARED lx, ly, lz, resx%, resy%

DIM SHARED MemSize AS INTEGER

MemSize = 2 '16 bit
IF DQBinit(1, 0, 4200) THEN DQBclose: PRINT DQBerror$: END
Loadfile "obc.3dt"
install
DQBinitvga
starttime& = TIMER
DO
    DQBclearlayer 1
    newtime& = TIMER
    IF newtime& - starttime& > 1 THEN writefps$ = STR$(fps%): fps% = 0: starttime& = TIMER
    fps% = fps% + 1
    'a$ = INKEY$
    r1 = r1 + 1
    r3 = r3 + 1
    IF r1 >= 359 THEN r1 = 0
    IF r3 >= 359 THEN r3 = 0
    dqbprint 1, writefps$, 0, 0, 15
    rotatepoints                                'rotate the 3d points en normals
    Cullpolygons                                'surfacehiding
    ShadePolygons                               'Shade polygons
    DrawObject                                  'zbuffer and draw the obeject
    Dqbcopylayer 1, VIDEO
LOOP UNTIL a$ = " "

DQBclose

REM $DYNAMIC
SUB Cullpolygons
'This algorithm for removing hidden faces was developed by Dave
'Cooper.
    'There is another method, by finding the dot product of the
    'plane's normal and the viewing vector, but this algorithm is
    'much faster because of its simplicity(and lack of floating point
    'calculations).
    FOR a = 0 TO maxpolys
	p1 = getems%(polys.p1, a)
	p2 = getems%(polys.p2, a)
	p3 = getems%(polys.p3, a)

	IF getems%(points.yview, p1) <= getems%(points.yview, p2) THEN
	    IF getems%(points.yview, p3) < getems%(points.yview, p1) THEN
		PTop = p3
		PNext = p1
		PLast = p2
	    ELSE
		PTop = p1
		PNext = p2
		PLast = p3
	    END IF
	ELSE
	    IF getems%(points.yview, p3) < getems%(points.yview, p2) THEN
		PTop = p3
		PNext = p1
		PLast = p2
	    ELSE
		PTop = p2
		PNext = p3
		PLast = p1
	    END IF
	END IF

	XLow = getems%(points.xview, PTop)
	YLow = getems%(points.yview, PTop)

	XNext = getems%(points.xview, PNext)
	XLast = getems%(points.xview, PLast)

	IF XNext <= XLow AND XLast >= XLow THEN
	    putems polys.culled, a, True
	ELSEIF XNext >= XLow AND XLast <= XLow THEN
	    putems polys.culled, a, False
	ELSE
	    YNext = getems%(points.yview, PNext)
	    YLast = getems%(points.yview, PLast)
IF ((YNext - YLow) * 256&) \ (XNext - XLow) < ((YLast - YLow) * 256&) \ (XLast - XLow) THEN
		putems polys.culled, a, False
	    ELSE
		putems polys.culled, a, True
	    END IF
	END IF

    NEXT
END SUB

SUB DrawObject


    'Find the center of each visible polygon, and prepare the orderlist.
    numpolys = 0
    FOR a = 0 TO maxpolys
	IF getems%(polys.culled, a) = False AND getems%(points.zworld, getems%(polys.p1, a)) > 1000 THEN 'is this polygon visible?
	   
	    putems polys.zorder, numpolys, a
	    numpolys = numpolys + 1
	    zc% = getems%(points.zworld, getems%(polys.p1, a)) + getems%(points.zworld, getems%(polys.p2, a)) + getems%(points.zworld, getems%(polys.p3, a))
	    putems polys.zcenter, a, INT(zc% / 3)
	END IF
    NEXT
    'Sort the visible polygons by their Z center using a shell sort.
    numpolys = numpolys - 1
    Mid = (numpolys + 1) \ 2
    DO
	FOR a = 0 TO numpolys - Mid
	    CompareLow = a
	    CompareHigh = a + Mid
		DO WHILE getems%(polys.zcenter, getems%(polys.zorder, CompareLow)) < getems%(polys.zcenter, getems%(polys.zorder, CompareHigh))
		am% = getems%(polys.zorder, CompareLow)
		bm% = getems%(polys.zorder, CompareHigh)
		SWAP am%, bm%
		putems polys.zorder, CompareLow, am%
		putems polys.zorder, CompareHigh, bm%
		CompareHigh = CompareLow
		CompareLow = CompareLow - Mid
		IF CompareLow < 0 THEN EXIT DO
	    LOOP
	NEXT
	Mid = Mid \ 2
    LOOP WHILE Mid > 0
    'Plot the visible polygons.





 
	
 
      FOR z = 0 TO numpolys
	a = getems%(polys.zorder, z)'which polygon do we plot?
	p1 = getems%(polys.p1, a): p2 = getems%(polys.p2, a): p3 = getems%(polys.p3, a)
	polyfill getems%(points.xview, p1), getems%(points.yview, p1), getems%(points.xview, p2), getems%(points.yview, p2), getems%(points.xview, p3), getems%(points.yview, p3), 0, getems%(polys.intensity, a) + 16
	'       Future.Emstritext getems%(points.xview, p1), getems%(points.yview, p1), getems%(points.xview, p2), getems%(points.yview, p2), getems%(points.xview, p3), getems%(points.yview, p3), 0, 0, 64, 32, 0, 64, texture%(polytext(a))
    NEXT
 
END SUB

SUB Findnormals
    FOR a = 0 TO maxpolys
	p1 = getems%(polys.p1, a): p2 = getems%(polys.p2, a): p3 = getems%(polys.p3, a)
   
	'find the vectors of 2 lines inside the polygon
	ax! = getems%(points.xobject, p2) - getems%(points.xobject, p1)
	ay! = getems%(points.yobject, p2) - getems%(points.yobject, p1)
	az! = getems%(points.zobject, p2) - getems%(points.zobject, p1)
   
	bx! = getems%(points.xobject, p3) - getems%(points.xobject, p2)
	by! = getems%(points.yobject, p3) - getems%(points.yobject, p2)
	bz! = getems%(points.zobject, p3) - getems%(points.zobject, p2)
   
	'find the cross product of the 2 vectors
	nx! = ay! * bz! - az! * by!
	ny! = az! * bx! - ax! * bz!
	nz! = ax! * by! - ay! * bx!
   
	'normalize the vector so it ranges from -1 to 1
	M! = SQR(nx! * nx! + ny! * ny! + nz! * nz!)
	IF M! <> 0 THEN nx! = nx! / M!: ny! = ny! / M!: nz! = nz! / M!
	'store the vector for later rotation(notice that it is scaled
	'up by 128 so it can be stored as an integer variable)
	putems polys.worldxn, a, (nx! * 128 + getems%(points.xobject, p1))
	'polys(a).worldxn = nx! * 128 + points(p1).xobject
	putems polys.worldyn, a, (ny! * 128 + getems%(points.yobject, p1))
	'polys(a).worldyn = ny! * 128 + points(p1).yobject
	putems polys.worldzn, a, (na! * 128 + getems%(points.zobject, p1))
	'polys(a).worldzn = nz! * 128 + points(p1).zobject
    NEXT
END SUB

FUNCTION getems% (var%, address%)
DQBpeek VARSEG(getems%), VARPTR(getems%), var% + address% * MemSize, MemSize
EXIT FUNCTION
END FUNCTION

REM $STATIC
SUB install
'setup the program
     'set320x200 16
     resx% = 320
     resy% = 200
'loadlaunch "english.lng"

x = x \ (maxpoints + 1): y = y \ (maxpoints + 1): z = z \ (maxpoints + 1)

'Precalculate the normal point of each polygon for fast Lambert shading

Findnormals

'Precalculate the sine table
a = 0

FOR a! = 0 TO (359 + 90) / 57.29 STEP 1 / 57.29
    SineTable(a) = SIN(a!) * 1024: a = a + 1
NEXT

'Some light source configurations won't work that great!



r1 = 0: R2 = 0: r3 = 0      'three angles of rotation
ox = 0: oy = 0: oz = 3000 'object's origin (this program cannot
			    'currently handle the object when it goes
		    'behind the viewer!)
S = 1: T = 0
'future.loadfont "fonts/hylas.fnt"

l1 = 70: l2 = 40           'light source's spherical coordinates
a1! = l1 / 57.29: a2! = l2 / 57.29

s1! = SIN(a1!): c1! = COS(a1!)
s2! = SIN(a2!): c2! = COS(a2!)
lx = 128 * s1! * c2!        'convert spherical coordinates to a vector
ly = 128 * s1! * s2!        'scale up by 128 for integer math
lz = 128 * c1!

FOR a = -128 TO 128         'precalculate the three light source tables
    lx(a + 128) = lx * a    'for fast Lambert shading
    ly(a + 128) = ly * a
    lz(a + 128) = lz * a
NEXT

r1 = 0: R2 = 0: r3 = 0      'three angles of rotation
ox = 0: oy = -50: oz = 1100 'object's origin (this program cannot
			    'currently handle the object when it goes
		    'behind the viewer!)
S = 1: T = 0
END SUB

REM $DYNAMIC
SUB Loadfile (file$)
OPEN file$ FOR INPUT AS #1
	INPUT #1, inline$          ' input number of points etc.
	maxpoints = VAL(inline$)
	FOR i% = 0 TO maxpoints
		INPUT #1, inline$
		putems points.xobject, i%, VAL(inline$)
		INPUT #1, inline$
		putems points.yobject, i%, VAL(inline$)
		INPUT #1, inline$
		putems points.zobject, i%, VAL(inline$)
		
	NEXT
	INPUT #1, inline$
	maxpolys = VAL(inline$)
	FOR i% = 0 TO maxpolys
		INPUT #1, inline$
		putems polys.p1, i%, VAL(inline$)
		INPUT #1, inline$
		putems polys.p2, i%, VAL(inline$)
		INPUT #1, inline$
		putems polys.p3, i%, VAL(inline$)
 
	NEXT
     
CLOSE #1
END SUB

REM $STATIC
SUB polyfill (x1, y1, x2, y2, x3, y3, C, texture) 'for QB 4.5 Guys
'Draws A Polygon To The Screen. Simply Finds The Start And Stop X
'coordinates For Each Scan Line Within The Polygon And Uses The
'LINE Command For Filling.
'find Lowest And High X & Y Coordinates
IF y1 < y2 THEN YLow = y1 ELSE YLow = y2
IF y3 < YLow THEN YLow = y3
IF y1 > y2 THEN YHigh = y1 ELSE YHigh = y2
IF y3 > YHigh THEN YHigh = y3
IF x1 < x2 THEN XLow = x1 ELSE XLow = x2
IF x3 < XLow THEN XLow = x3
IF x1 > x2 THEN XHigh = x1 ELSE XHigh = x2
IF x3 > XHigh THEN XHigh = x3
IF YLow < 0 THEN YLow = 0
IF YHigh > 199 THEN YHigh = 199
IF XLow < XLow(S) THEN XLow(S) = XLow
IF XHigh > XHigh(S) THEN XHigh(S) = XHigh
IF YLow < YLow(S) THEN YLow(S) = YLow
IF YHigh > YHigh(S) THEN YHigh(S) = YHigh
'check For Polygons Which Cannot Be Visible
IF YHigh < 0 OR YLow > 199 OR XLow > 319 OR XHigh < 0 THEN EXIT SUB
'initialize The Edge List

'FOR a = YLow TO YHigh
'        EdgeList(a).Low = 32767
'        EdgeList(a).High = -32768
'NEXT

'Remember The Lowest & Highest X And Y Coordinates Drawn To The
'screen For Later Erasing
'Find The Start And Stop X Coordinates For Each Scan Line
'IF points(a).viewed = 1 THEN
'IF (x1 <= 0 OR x1 >= 320) AND (y1 <= 0 OR y1 >= 320) THEN
dqbtri 1, x1, y1, x2, y2, x3, y3, texture

END SUB

REM $DYNAMIC
SUB putems (var%, address%, vardata%)
DQBpoke VARSEG(vardata%), VARPTR(vardata%), var% + address% * MemSize, MemSize
END SUB

REM $STATIC
SUB rotatepoints
'    resx% = resx% - 200
xd! = 400& * resx% / 320
yd! = 300& * resy% / 200
rx% = resx% / 2
ry% = resy% / 2
    'lookup the sine and cosine of each angle...
    s1& = SineTable(r1): c1& = SineTable(r1 + 90)
    s2& = SineTable(R2): c2& = SineTable(R2 + 90)
    s3& = SineTable(r3): C3& = SineTable(r3 + 90)

    'rotate the points of the object
    FOR a = 0 TO maxpoints
	xo = getems%(points.xobject, a)
	yo = getems%(points.yobject, a)
	zo = getems%(points.zobject, a)
	GOSUB Rotate3D
	   IF z3 < 40 AND z3 > -500 THEN
	xview = rx% + (x2 * xd!) \ z3
	yview = ry% + (y3 * yd!) \ z3
	putems points.xview, a, xview
	putems points.yview, a, yview
	'IF y3 > 300 THEN STOP

	
	putems points.xworld, a, x2
	putems points.yworld, a, y3
	putems points.zworld, a, z3
	END IF
   NEXT
    'rotate the normals of each polygon...
    FOR a = 0 TO maxpolys
	xo = getems%(polys.worldxn, a)
	yo = getems%(polys.worldyn, a)
	zo = getems%(polys.worldzn, a)
	GOSUB Rotate3D
	p1 = getems%(polys.p1, a)
	'unorigin the point
	x2 = x2 - getems%(points.xworld, p1)
	y3 = y3 - getems%(points.yworld, p1)
	z3 = z3 - getems%(points.zworld, p1)
	'check the bounds just in case of a round off error
	IF x2 < -128 THEN x2 = -128 ELSE IF x2 > 128 THEN x2 = 128
	IF y3 < -128 THEN y3 = -128 ELSE IF y3 > 128 THEN y3 = 128
	IF z3 < -128 THEN z3 = -128 ELSE IF z3 > 128 THEN z3 = 128
	'store the normal back; it's now ready for the shading
	'calculations (which are simplistic now)
	putems polys.normalx, a, x2 + 128
	'polys(a).normalx = x2 + 128
	putems polys.normaly, a, y3 + 128
	'polys(a).normaly = y3 + 128
	putems polys.normalz, a, z3 + 128
	'polys(a).normalz = z3 + 128
    NEXT
    ' resx% = resx% + 200
    EXIT SUB

Rotate3D:
    x1 = (xo * c1& - zo * s1&) \ 1024 'yaw
    z1 = (xo * s1& + zo * c1&) \ 1024

    z3 = (z1 * C3& - yo * s3&) \ 1024 + oz 'pitch
    y2 = (z1 * s3& + yo * C3&) \ 1024

    x2 = (x1 * c2& + y2 * s2&) \ 1024 + ox 'roll
    y3 = (y2 * c2& - x1 * s2&) \ 1024 + oy

RETURN
END SUB

SUB setup
'setup the program
     'set320x200 16
     resx% = 320
     resy% = 200
'loadlaunch "english.lng"

x = x \ (maxpoints + 1): y = y \ (maxpoints + 1): z = z \ (maxpoints + 1)

'Precalculate the normal point of each polygon for fast Lambert shading

Findnormals

'Precalculate the sine table
a = 0

FOR a! = 0 TO (359 + 90) / 57.29 STEP 1 / 57.29
    SineTable(a) = SIN(a!) * 1024: a = a + 1
NEXT

'Some light source configurations won't work that great!



r1 = 0: R2 = 0: r3 = 0      'three angles of rotation
ox = 0: oy = 0: oz = 3000 'object's origin (this program cannot
			    'currently handle the object when it goes
		    'behind the viewer!)
S = 1: T = 0
'future.loadfont "fonts/hylas.fnt"

l1 = 70: l2 = 40           'light source's spherical coordinates
a1! = l1 / 57.29: a2! = l2 / 57.29

s1! = SIN(a1!): c1! = COS(a1!)
s2! = SIN(a2!): c2! = COS(a2!)
lx = 128 * s1! * c2!        'convert spherical coordinates to a vector
ly = 128 * s1! * s2!        'scale up by 128 for integer math
lz = 128 * c1!

FOR a = -128 TO 128         'precalculate the three light source tables
    lx(a + 128) = lx * a    'for fast Lambert shading
    ly(a + 128) = ly * a
    lz(a + 128) = lz * a
NEXT

r1 = 0: R2 = 0: r3 = 0      'three angles of rotation
ox = 0: oy = -50: oz = 1100 'object's origin (this program cannot
			    'currently handle the object when it goes
		    'behind the viewer!)
S = 1: T = 0
END SUB

SUB ShadePolygons
    FOR a = 0 TO maxpolys
	IF getems%(polys.culled, a) = False THEN
  
	 'lookup the polygon's normal for shading
	 '(128*128)\15 = 1092
	 intensity = (lx(getems%(polys.normalx, a)) + ly(getems%(polys.normaly, a)) + lz(getems%(polys.normalz, a))) \ 1092
	 IF intensity < 0 THEN intensity = 0
	 intensity = intensity + 5
	 IF intensity > 15 THEN intensity = 15
	 putems polys.intensity, a, intensity
	END IF
    NEXT
END SUB

